// HelloWin.cpp
// compile with: /D_UNICODE /DUNICODE /DWIN32 /D_WINDOWS /c

#include "stdafx.h"
#include <windows.h>
#include <Commctrl.h>
#include <vector>

#pragma comment(lib, "D:\\VS2010\\WinLIFT64.lib")
#pragma comment(lib, "D:\\VS2010\\WinLIFT32.lib")
#include "WinLIFT.h"

#define MyWindowWidth      800
#define MyWindowHeight     540

#define IDC_MAIN_STATICIMG 1009

// Main winproc
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    long wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    switch (uMsg)
    {
    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);
         return 0;

    case WM_PAINT:
         hdc = BeginPaint(hWnd, &ps);
         // TODO: process here the WM_PAINT message...
         EndPaint(hWnd, &ps);
         return 0;

    case WM_DESTROY:
         PostQuitMessage(0);
         return 0;
    }
   
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}  

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Declaration of local variables
    long nRet = 0, IsInitialized = 0;
    WNDCLASSEX wcx; MSG msg;
    WCHAR szWindowClass[] = L"WLFT";
    WCHAR szTitle[64];
    if (sizeof(LONG_PTR) == 8) {
        wcscpy_s(szTitle, L"WinLIFT-64 Template"); }
    else {
        wcscpy_s(szTitle, L"WinLIFT-32 Template");
    }

    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized)
    {
        wcx.style         = CS_HREDRAW | CS_VREDRAW;
        wcx.lpfnWndProc   = WndProc;
        wcx.cbClsExtra    = 0;
        wcx.cbWndExtra    = 0;
        wcx.hInstance     = hInstance;
        wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcx.lpszMenuName  = NULL;
        wcx.lpszClassName = szWindowClass;
        wcx.hIconSm       = LoadIcon(wcx.hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
        if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
     }

     if (IsInitialized) {  

        long w = MyWindowWidth;
        long h = MyWindowHeight;
        long x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
        long y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

        DWORD dwStyle = WS_POPUP | WS_THICKFRAME | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX |
                        WS_MAXIMIZEBOX | WS_CLIPSIBLINGS | WS_CLIPCHILDREN; // | WS_VISIBLE

        HWND hWnd = CreateWindowEx(
                    0,                              // Optional window styles.
                    szWindowClass,                  // Window class
                    szTitle,                        // Window text
                    dwStyle,                        // Window style
    
                    // Size and position
                    x, y, w, h,
    
                    NULL,       // Parent window    
                    NULL,       // Menu
                    hInstance,  // Instance handle
                    NULL        // Additional application data
                    );
    
        if (hWnd) {

            wstring sExePath;
            WCHAR exepath[MAX_PATH]; 
            if (GetModuleFileName(0, exepath, sizeof(exepath))) {
                sExePath = exepath; sExePath = sExePath.substr( 0, sExePath.rfind(L"\\")); sExePath += L"\\";
            }

            wstring SkinTheme = sExePath; SkinTheme += L"Sony.sks";
            if (skInitEngine ((WCHAR*) SkinTheme.c_str(), L"")) {
                skSkinWindow(hWnd, L"Dock|Undock|Minimize|Maximize|Restore|Close");

                // Optional WinLIFT static image background.
                wstring sResource = sExePath;  sResource += L"Resource\\Assistant.png";
                HWND hCtrl = skStaticImage (hWnd, (WCHAR*) sResource.c_str(), 580, 20, 185, 456, IDC_MAIN_STATICIMG);   
                skSetAnchorCtrl(hCtrl, ANCHOR_HEIGHT_RIGHT);

            }

            ShowWindow(hWnd, nCmdShow);
            UpdateWindow(hWnd);
    
            // Main message loop
            while (GetMessage(&msg, NULL, 0, 0))
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
            nRet = (long) msg.wParam;
        }
     }
     return nRet;
}
